﻿using System;
using System.Collections.Generic;
using System.IO;
using System.Linq;
using System.Text;
using System.Threading;
using System.Threading.Tasks;
using PS4000A_sigAWG;

namespace PicoScopeReader
{
    class BlockReadThread
    {
        private static ChannelSettings[] _channelSettings;
        private static short _channelCount = 8;
        private static uint timebase = 1; // 5000 Hz         //15 - 5MHz
        private static int noSamples;
        private static ushort segmentIndex;
        private static int maxSamples;
        private static int timeIntervalNanoseconds;
        private static int timeIndisposedMs;
        private static uint startIndex = 0;
        private static uint _startIndex = 0;
        private static uint downSampleRatio;
        private static short overflow;
        private static uint noOfSamples = 1000;
        private static Boolean _read = true;
        private static short[] minBuffers;
        private static short[] maxBuffers;
        private static short[] _minBuffersTemp;
        private static short[] _maxBuffersTemp;
        private static PinnedArray<short>[] _minPinned;
        private static PinnedArray<short>[] _maxPinned;
        private static PinnedArray<short>[] _minPinnedTemp;
        private static PinnedArray<short>[] _maxPinnedTemp;
        private static string _filePathB;
        private static Object semafor = new Object();

        public static void Read(short handle, int status, string filePathA, string filePathB)
        {
            _read = true;

            _filePathB = filePathB;

            SetDefaults(handle);

            status = Imports.GetTimebase(handle, timebase, noSamples, out timeIntervalNanoseconds, out maxSamples, segmentIndex);
            SetTrigger(null, 0, null, 0, null, null, 0, 0, 0, handle);

            _minPinned = new PinnedArray<short>[8];
            _maxPinned = new PinnedArray<short>[8];

            //for (int i = 0; i < 8; i++)
            //{
            //    minBuffers = new short[noOfSamples];
            //    maxBuffers = new short[noOfSamples];
            //    _minPinned[i] = new PinnedArray<short>(minBuffers);
            //    _maxPinned[i] = new PinnedArray<short>(maxBuffers);

            //    status = Imports.SetDataBuffers(handle, (Imports.Channel)i, maxBuffers, minBuffers, (int)noOfSamples, 0, Imports.DownSamplingMode.None);
            //}
            int nMaxSamples = 1000;
            ushort nSegments = 6250; //(ushort)(nMaxSamples / (2 * noOfSamples));
            uint nWaveforms = 10;
            status = Imports.MemorySegments(handle, nSegments, out nMaxSamples);
            status = Imports.SetNoOfRapidCaptures(handle, nWaveforms);

            //status = (short)Imports.RunBlock(handle, (short)0, (short)noOfSamples, timebase, out timeIndisposedMs, 0, BlockCallback, IntPtr.Zero);

            

            while (_read)
            {
                status = (short)Imports.RunBlock(handle, (short)0, (short)noOfSamples, timebase, out timeIndisposedMs, 0, BlockCallback, IntPtr.Zero);
            }



        }

        /// <summary>
        /// callback
        /// </summary>
        /// <param name="handle"></param>
        /// <param name="status"></param>
        /// <param name="pVoid"></param>
        private static void BlockCallback(short handle, short status, IntPtr pVoid)
        {
            
            //status = (short)Imports.GetValues(handle, startIndex, ref noOfSamples, downSampleRatio, Imports.DownSamplingMode.None, segmentIndex, out overflow);
            //_minBuffersTemp = minBuffers;
            //_maxBuffersTemp = maxBuffers;
            //_startIndex = startIndex;
            //_minPinnedTemp = _minPinned;
            //_maxPinnedTemp = _maxPinned;
            //PinnedArray<short>[] maxPinnedTemp = new PinnedArray<short>[noOfSamples];
            //_maxPinned.CopyTo(maxPinnedTemp, 0);

            for (int i = 0; i < 2; i++)
            {
                maxBuffers = new short[noOfSamples];
                _maxPinned[i] = new PinnedArray<short>(maxBuffers);

                status = (short)Imports.SetDataBuffer(handle, (Imports.Channel)i, maxBuffers, (int)noOfSamples, 0, Imports.DownSamplingMode.None);
            }

            ushort fromSegmentIndex = 1;
            ushort toSegmentIndex = 2;
            short[] overflows = null;
            status = (short)Imports.GetValuesBulk(handle, ref noOfSamples, fromSegmentIndex, toSegmentIndex, 0, Imports.DownSamplingMode.None, overflows);
            //fromSegmentIndex = (ushort)overflows[0];
            //toSegmentIndex = (ushort)overflows[overflows.Length-1];

            uint timesUpper = 0;
            uint timesLower = 0;
            status = (short)Imports.GetValuesTriggerTimeOffsetBulk(handle, ref timesUpper, ref timesLower, (ushort)fromSegmentIndex, (ushort)toSegmentIndex);

            Thread t = new Thread(() => BlockReadThread.SaveBuffers(_maxPinned));
            t.Start();
        }

        private static void SaveBuffers(PinnedArray<short>[] maxPinned)
        {
            List<string> channelB_list = new List<string>();
            System.Diagnostics.Stopwatch st = new System.Diagnostics.Stopwatch();

            st.Start();
            for (uint i = _startIndex; i < (_startIndex + noOfSamples); i++)
            {
                for (int ch = 0; ch < 8; ch++)
                {
                    if (_channelSettings[ch].enabled)
                    {
                        StringBuilder bbb = new StringBuilder();

                        if (ch == 1)
                        {
                            bbb.AppendLine(adc_to_mv(maxPinned[ch].Target[i], (int)_channelSettings[(int)(Imports.Channel.CHANNEL_A + ch)].range).ToString());
                            channelB_list.Add(bbb.ToString());
                        }
                    }
                }
            }

            string[][] outputB = 
                        {
                            channelB_list.ToArray()
                        };
            StringBuilder sbB = new StringBuilder();

            int lengthB = outputB.GetLength(0);
            sbB = new StringBuilder();
            for (int index = 0; index < lengthB; index++)
                sbB.AppendLine(string.Join(Config.DELIMITER.ToString(), outputB[index]));

            
            st.Stop();
            lock (semafor) 
            {
                File.AppendAllText(_filePathB, sbB.ToString());
            }

            string aaa = st.ElapsedMilliseconds.ToString();
        }

        /// <summary>
        /// przeliczenie
        /// </summary>
        /// <param name="raw"></param>
        /// <param name="ch"></param>
        /// <returns></returns>
        private static int adc_to_mv(int raw, int ch)
        {
            return (raw * Config.INPUT_RANGES[ch]) / Imports.MaxValue;
        }

        /// <summary>
        /// Metoda ustawaiajaca kanaly
        /// </summary>
        /// <param name="handle"></param>
        private static void SetDefaults(short handle)
        {
            _channelSettings = new ChannelSettings[_channelCount];

            for (int i = 0; i < _channelCount; i++)
            {
                _channelSettings[i].enabled = true;
                _channelSettings[i].DCcoupled = true;
                _channelSettings[i].range = Imports.Range.Range_5V;
            }

            for (int i = 0; i < _channelCount; i++) // reset channels to most recent settings
            {
                try
                {
                    Imports.SetChannel(handle, Imports.Channel.CHANNEL_A + i,
                                       (short)(_channelSettings[(int)(Imports.Channel.CHANNEL_A + i)].enabled ? 1 : 0),
                                       (short)(_channelSettings[(int)(Imports.Channel.CHANNEL_A + i)].DCcoupled ? 1 : 0),
                                       _channelSettings[(int)(Imports.Channel.CHANNEL_A + i)].range,
                                       (float)Imports.Range.Range_5V);
                }
                catch (Exception ex)
                {


                }
            }
        }

        /// <summary>
        /// Ustawienie trigerow
        /// </summary>
        /// <param name="channelProperties"></param>
        /// <param name="nChannelProperties"></param>
        /// <param name="triggerConditions"></param>
        /// <param name="nTriggerConditions"></param>
        /// <param name="directions"></param>
        /// <param name="pwq"></param>
        /// <param name="delay"></param>
        /// <param name="auxOutputEnabled"></param>
        /// <param name="autoTriggerMs"></param>
        /// <param name="handle"></param>
        /// <returns></returns>
        private static short SetTrigger(Imports.TriggerChannelProperties[] channelProperties, short nChannelProperties, Imports.TriggerConditions[] triggerConditions, short nTriggerConditions, Imports.ThresholdDirection[] directions, Pwq pwq, uint delay, short auxOutputEnabled, int autoTriggerMs, short handle)
        {
            short status;

            if ((status = (short)Imports.SetTriggerChannelProperties(handle, ref channelProperties, nChannelProperties, auxOutputEnabled, autoTriggerMs)) != 0)
            {
                return status;
            }

            if ((status = (short)Imports.SetTriggerChannelConditions(handle, ref triggerConditions, nTriggerConditions, Imports.INFO.Clear)) != 0)
            {
                return status;
            }

            if (directions == null)
            {
                directions = new Imports.ThresholdDirection[] { Imports.ThresholdDirection.None, 
                                                                Imports.ThresholdDirection.None, 
                                                                Imports.ThresholdDirection.None, 
                                                                Imports.ThresholdDirection.None, 
                                                                Imports.ThresholdDirection.None, 
                                                                Imports.ThresholdDirection.None};
            }

            Imports.TriggerDirections[] trigerDirections = new Imports.TriggerDirections[] { 
                                                new Imports.TriggerDirections(Imports.Channel.CHANNEL_A, Imports.ThresholdDirection.None),
                                                new Imports.TriggerDirections(Imports.Channel.CHANNEL_B, Imports.ThresholdDirection.RisingOrFalling),
                                                new Imports.TriggerDirections(Imports.Channel.CHANNEL_C, Imports.ThresholdDirection.None),
                                                new Imports.TriggerDirections(Imports.Channel.CHANNEL_D, Imports.ThresholdDirection.None),
                                                new Imports.TriggerDirections(Imports.Channel.CHANNEL_E, Imports.ThresholdDirection.None),
                                                new Imports.TriggerDirections(Imports.Channel.CHANNEL_F, Imports.ThresholdDirection.None),
                                                new Imports.TriggerDirections(Imports.Channel.CHANNEL_G, Imports.ThresholdDirection.None),
                                                new Imports.TriggerDirections(Imports.Channel.CHANNEL_H, Imports.ThresholdDirection.None)};

            if ((status = (short)Imports.SetTriggerChannelDirections(handle, ref trigerDirections, (short)directions.Length)) != 0)
            {
                return status;
            }

            if ((status = (short)Imports.SetTriggerDelay(handle, delay)) != 0)
            {
                return status;
            }

            if (pwq == null) pwq = new Pwq(null, 0, Imports.ThresholdDirection.None, 0, 0, Imports.PulseWidthType.None);

            //status = (short) Imports.SetPulseWidthQualifier(handle, pwq.conditions,
            //                                        pwq.nConditions, pwq.direction,
            //                                        pwq.lower, pwq.upper, pwq.type);

            return status;
        }

        /// <summary>
        /// Metoda do zatrzymania watku
        /// </summary>
        public static void StopRead()
        {
            _read = false;
        }
    }
}
