﻿using System;
using System.Runtime.InteropServices;
using System.Text;

namespace PicoScopeReader
{
    class Wrapper
    {
        private const string _DRIVER_FILENAME = "ps4000aWrap.dll";

        [DllImport(_DRIVER_FILENAME, EntryPoint = "RunBlock")]
        public static extern Int32 RunBlock
        (
            short handle,
            int preTriggerSamples,
            int postTriggerSamples,
            uint timebase,
            uint segmentIndex
        );

        [DllImport(_DRIVER_FILENAME, EntryPoint = "GetStreamingLatestValues")]
        public static extern Int32 GetStreamingLatestValues
        (
            short handle
        );

        [DllImport(_DRIVER_FILENAME, EntryPoint = "AvailableData")]
        public static extern Int32 AvailableData
        (
            short handle,
            ref uint startIndex
        );

        [DllImport(_DRIVER_FILENAME, EntryPoint = "AutoStopped")]
        public static extern Int32 AutoStopped
        (
            short handle
        );

        [DllImport(_DRIVER_FILENAME, EntryPoint = "IsReady")]
        public static extern Int32 IsReady
        (
            short handle
        );

        [DllImport(_DRIVER_FILENAME, EntryPoint = "IsTriggerReady")]
        public static extern Int32 IsTriggerReady
        (
            short handle,
            ref uint triggeredAt
        );

        [DllImport(_DRIVER_FILENAME, EntryPoint = "ClearTriggerReady")]
        public static extern Int32 ClearTriggerReady
        (
            short handle
        );

        [DllImport(_DRIVER_FILENAME, EntryPoint = "setChannelCount")]
        public static extern Int32 SetChannelCount
        (
            short handle,
            short channelCount
        );

        [DllImport(_DRIVER_FILENAME, EntryPoint = "setEnabledChannels")]
        public static extern Int32 SetEnabledChannels
        (
            short handle,
            ref short enabledChannels
        );

        [DllImport(_DRIVER_FILENAME, EntryPoint = "setAppAndDriverBuffers")]
        public static extern Int32 SetAppAndDriverBuffers
        (
            short handle,
            short channel,
            ref short appBuffer,
            ref short driverBuffer,
            int bufferLength
        );

        [DllImport(_DRIVER_FILENAME, EntryPoint = "setMaxMinAppAndDriverBuffers")]
        public static extern Int32 SetMaxMinAppAndDriverBuffers
        (
            short handle,
            short channel,
            ref short appMaxBuffer,
            ref short appMinBuffer,
            ref short driverMaxBuffer,
            ref short driverMinBuffer,
            int bufferLength
        );
    }
}
