﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Threading;
using System.IO;
using PS4000A_sigAWG;
using System.Runtime.InteropServices;

namespace PicoScopeReader
{
    struct ChannelSettings
    {
        public bool DCcoupled;
        public Imports.Range range;
        public bool enabled;
    }

    class Pwq
    {
        public Imports.PwqConditions[] conditions;
        public short nConditions;
        public Imports.ThresholdDirection direction;
        public uint lower;
        public uint upper;
        public Imports.PulseWidthType type;

        public Pwq(Imports.PwqConditions[] conditions,
            short nConditions,
            Imports.ThresholdDirection direction,
            uint lower, uint upper,
            Imports.PulseWidthType type)
        {
            this.conditions = conditions;
            this.nConditions = nConditions;
            this.direction = direction;
            this.lower = lower;
            this.upper = upper;
            this.type = type;
        }
    }

    class ReadThread
    {
        /// <summary>
        /// Zmienna okreslajaca czy watek ma dzialac
        /// </summary>
        private static Boolean _read = true;

        private static Boolean _ready = false;

        private static short _trig = 0;
        private static uint _trigAt = 0;
        private static int _sampleCount = 0;
        private static uint _startIndex = 0;
        private static bool _autoStop;
        private static ChannelSettings[] _channelSettings;
        private static short _channelCount = 8;

        public static int counter = 0;
        public static List<string> channelA_list = new List<string>();
        public static List<string> channelB_list = new List<string>();

        public static int Run(ref short handle)
        {
            int status;
            status = Imports.OpenUnit(out handle, null);
            return status;
        }

        /// <summary>
        /// Metoda sluzaca do obslugi picoscopu (czytanie danych i wrzucanie do pliku)
        /// </summary>
        /// <param name="handle"></param>
        /// <param name="status"></param>
        /// <param name="filePath"></param>
        public static void Read(short handle, int status, string filePathA, string filePathB)
        {
            _read = true; // na dzien dobry ustalamy ze dziala, bo moglo zostac wczesniej zmienione na false
            
            uint totalsamples = 0;
            uint triggeredAt = 0;
            uint sampleInterval = 200; /* ilosc sekund/milisekund/mikrosekund/nanosekund w zaleznosci od  Imports.ReportedTimeUnits*/
            uint sampleCount = 1000000; /* rozmiar bufora */
            uint preTrigger = 1000000;

            if (!_read) _ready = false;

            while (_read)
            {
                if (handle != 0)
                {
                    //if not usb3 will need to set up systrem to get  the opwer from usb 2.0
                    if (status != 0)
                    {
                        try
                        {
                            status = Imports.ps4000aChangePowerSource(handle, status);
                        }
                        catch
                        {

                        }
                    }

                    PinnedArray<short>[] minPinned = new PinnedArray<short>[8];
                    PinnedArray<short>[] maxPinned = new PinnedArray<short>[8];
                    //PinnedArray<short>[] driverMinPinned = new PinnedArray<short>[8];
                    //PinnedArray<short>[] driverMaxPinned = new PinnedArray<short>[8];


                    Imports.ps4000aBlockReady _callbackDelegate;
                    _callbackDelegate = BlockCallback;

                    SetDefaults(handle);
                    //Wrapper.SetChannelCount(handle, _channelCount);
                    //Wrapper.SetEnabledChannels(handle, ref _channelCount);


                    SetTrigger(null, 0, null, 0, null, null, 0, 0, 0, handle);

                    for (int i = 0; i < 8; i++)
                    {
                        short[] minBuffers = new short[sampleCount];
                        short[] maxBuffers = new short[sampleCount];
      //                  short[] driverMinBuffers = new short[sampleCount];
    //                    short[] driverMaxBuffers = new short[sampleCount];
                        minPinned[i] = new PinnedArray<short>(minBuffers);
                        maxPinned[i] = new PinnedArray<short>(maxBuffers);
  //                      driverMinPinned[i] = new PinnedArray<short>(driverMinBuffers);
//                        driverMaxPinned[i] = new PinnedArray<short>(driverMaxBuffers);

                        status = Imports.SetDataBuffers(handle, (Imports.Channel)i, maxBuffers, minBuffers, (int)sampleCount, 0, Imports.DownSamplingMode.None);
                        
        //                short appBuffer = 0;
          //              short driverBuffer = 0;
            //            Wrapper.SetAppAndDriverBuffers(handle, (short)i, ref appBuffer, ref driverBuffer, (int)sampleCount);
                    }

                    

                    status = Imports.RunStreaming(handle, ref sampleInterval, Imports.ReportedTimeUnits.NanoSeconds, preTrigger, preTrigger - preTrigger, false, 1, Imports.DownSamplingMode.None, sampleCount);
                    

                    Thread.Sleep(35);
                    uint startIndex = 0;
                    int isReady;
                    int availableData;
                    //uint triggeredAt = 0;
                    while (_read)
                    {
                        if (_ready == false && GetStreamingLatestValuesBool == true)
                        {
                            GetStreamingLatestValuesBool = false;
                            status = Imports.GetStreamingLatestValues(handle, StreamingCallback, IntPtr.Zero);
              //              status = Wrapper.GetStreamingLatestValues(handle);
            //                isReady = Wrapper.IsReady(handle);
                        }

                     //   availableData = Wrapper.AvailableData(handle, ref startIndex);
                       // Wrapper.IsTriggerReady(handle, ref triggeredAt);

                        if (_ready && _sampleCount > 0) /* can be ready and have no data, if autoStop has fired */
                        {
                            if (_trig > 0)
                                triggeredAt = totalsamples + _trigAt;
                            totalsamples += (uint)_sampleCount;

                            for (uint i = _startIndex; i < (_startIndex + _sampleCount); i++)
                            {
                                for (int ch = 0; ch < 8; ch++)
                                {
                                    if (_channelSettings[ch].enabled)
                                    {
                                        StringBuilder aaa = new StringBuilder();
                                        StringBuilder bbb = new StringBuilder();

                                        #region
                                        //int q = minPinned[ch].Target[i];
                                        //int qq = adc_to_mv(minPinned[ch].Target[i], (int)_channelSettings[(int)(Imports.Channel.CHANNEL_A + ch)].range);
                                        //int qqqq = maxPinned[ch].Target[i];
                                        //int qqqqq = adc_to_mv(maxPinned[ch].Target[i], (int)_channelSettings[(int)(Imports.Channel.CHANNEL_A + ch)].range);

                                        //aaa.AppendFormat("Ch{0} {1,7}   {2,7}   {3,7}   {4,7}   ",
                                        //                     (char)('A' + ch),
                                        //                     minPinned[ch].Target[i],
                                        //                     adc_to_mv(minPinned[ch].Target[i], (int)_channelSettings[(int)(Imports.Channel.CHANNEL_A + ch)].range),
                                        //                     maxPinned[ch].Target[i],
                                        //                     adc_to_mv(maxPinned[ch].Target[i], (int)_channelSettings[(int)(Imports.Channel.CHANNEL_A + ch)].range));
                                        #endregion

                                        //if (ch == 0)
                                        //{
                                        //    aaa.AppendLine(maxPinned[ch].Target[i].ToString() + "," + adc_to_mv(maxPinned[ch].Target[i], (int)_channelSettings[(int)(Imports.Channel.CHANNEL_A + ch)].range));
                                        //    channelA_list.Add(aaa.ToString());
                                        //}
                                        if (ch == 1)
                                        {
                                            bbb.AppendLine(adc_to_mv(maxPinned[ch].Target[i], (int)_channelSettings[(int)(Imports.Channel.CHANNEL_A + ch)].range).ToString());
                                            channelB_list.Add(bbb.ToString());
                                        }
                                    }
                                }
                            }
                        }

                        string[][] outputB = 
                        {
                            channelB_list.ToArray()
                        };

                        StringBuilder sbB = new StringBuilder();

                        int lengthB = outputB.GetLength(0);
                        sbB = new StringBuilder();
                        for (int index = 0; index < lengthB; index++)
                            sbB.AppendLine(string.Join(Convert.ToString(Config.DELIMITER), outputB[index]));

                        File.AppendAllText(filePathB, sbB.ToString());

                    }
                }
                else
                {
                    status = Run(ref handle);
                }
            }
        }
        /// <summary>
        /// Metoda do zatrzymania watku
        /// </summary>
        public static void StopRead()
        {
            _read = false;
        }

        private static void BlockCallback(short handle, short status, IntPtr pVoid)
        {
            // flag to say done reading data
            _ready = true;
        }

        private static int adc_to_mv(int raw, int ch)
        {
            return (raw * Config.INPUT_RANGES[ch]) / Imports.MaxValue;
        }

        /****************************************************************************
        * Callback
        * used by PS4000 data streaimng collection calls, on receipt of data.
        * used to set global flags etc checked by user routines
        ****************************************************************************/
        private static void StreamingCallback(short handle, int noOfSamples, uint startIndex, short ov, uint triggerAt, short triggered, short autoStop, IntPtr pVoid)
        {
            // used for streaming
            _sampleCount = noOfSamples;
            _startIndex = startIndex;
            _autoStop = autoStop != 0;

            // flag to say done reading data
            _ready = true;

            // flags to show if & where a trigger has occurred
            _trig = triggered;
            _trigAt = triggerAt;

            
        }

        /****************************************************************************
         * SetDefaults - restore default settings
         ****************************************************************************/
        private static void SetDefaults(short handle)
        {
            _channelSettings = new ChannelSettings[_channelCount];

            for (int i = 0; i < _channelCount; i++)
            {
                _channelSettings[i].enabled = true;
                _channelSettings[i].DCcoupled = true;
                _channelSettings[i].range = Imports.Range.Range_5V;
            }

            for (int i = 0; i < _channelCount; i++) // reset channels to most recent settings
            {
                try
                {
                    Imports.SetChannel(handle, 
                                        Imports.Channel.CHANNEL_A + i,
                                       (short)(_channelSettings[(int)(Imports.Channel.CHANNEL_A + i)].enabled ? 1 : 0),
                                       (short)(_channelSettings[(int)(Imports.Channel.CHANNEL_A + i)].DCcoupled ? 1 : 0),
                                       _channelSettings[(int)(Imports.Channel.CHANNEL_A + i)].range,
                                       (float)Imports.Range.Range_5V);
                }
                catch (Exception ex)
                {


                }
            }
        }


        /****************************************************************************
        *  SetTrigger
        *  this function sets all the required trigger parameters, and calls the 
        *  triggering functions
        ****************************************************************************/
        private static short SetTrigger(Imports.TriggerChannelProperties[] channelProperties, short nChannelProperties, Imports.TriggerConditions[] triggerConditions, short nTriggerConditions, Imports.ThresholdDirection[] directions, Pwq pwq, uint delay, short auxOutputEnabled, int autoTriggerMs, short handle)
        {
            short status;

            if ((status = (short) Imports.SetTriggerChannelProperties(handle, ref channelProperties, nChannelProperties, auxOutputEnabled, autoTriggerMs)) != 0)
            {
                return status;
            }

            if ((status = (short) Imports.SetTriggerChannelConditions(handle, ref triggerConditions, nTriggerConditions, Imports.INFO.Clear)) != 0)
            {
                return status;
            }

            if (directions == null)
            {
                directions = new Imports.ThresholdDirection[] { Imports.ThresholdDirection.None, 
                                                                Imports.ThresholdDirection.None, 
                                                                Imports.ThresholdDirection.None, 
                                                                Imports.ThresholdDirection.None, 
                                                                Imports.ThresholdDirection.None, 
                                                                Imports.ThresholdDirection.None};
            }

            Imports.TriggerDirections[] trigerDirections = new Imports.TriggerDirections[] { 
                                                new Imports.TriggerDirections(Imports.Channel.CHANNEL_A, Imports.ThresholdDirection.None),
                                                new Imports.TriggerDirections(Imports.Channel.CHANNEL_B, Imports.ThresholdDirection.RisingOrFalling),
                                                new Imports.TriggerDirections(Imports.Channel.CHANNEL_C, Imports.ThresholdDirection.None),
                                                new Imports.TriggerDirections(Imports.Channel.CHANNEL_D, Imports.ThresholdDirection.None),
                                                new Imports.TriggerDirections(Imports.Channel.CHANNEL_E, Imports.ThresholdDirection.None),
                                                new Imports.TriggerDirections(Imports.Channel.CHANNEL_F, Imports.ThresholdDirection.None),
                                                new Imports.TriggerDirections(Imports.Channel.CHANNEL_G, Imports.ThresholdDirection.None),
                                                new Imports.TriggerDirections(Imports.Channel.CHANNEL_H, Imports.ThresholdDirection.None)};

            if ((status = (short) Imports.SetTriggerChannelDirections(handle, ref trigerDirections, (short)directions.Length)) != 0)
            {
                return status;
            }

            if ((status = (short) Imports.SetTriggerDelay(handle, delay)) != 0)
            {
                return status;
            }

            if (pwq == null) pwq = new Pwq(null, 0, Imports.ThresholdDirection.None, 0, 0, Imports.PulseWidthType.None);

            //status = (short) Imports.SetPulseWidthQualifier(handle, pwq.conditions,
            //                                        pwq.nConditions, pwq.direction,
            //                                        pwq.lower, pwq.upper, pwq.type);

            return status;
        }

        public static bool GetStreamingLatestValuesBool = true;
    }
}
